<script>
import shortid from 'shortid';

export default {
  name: `anim-rig-poses-grid-item`,
  props: {
    item: { type: Object, required: true },
    lib: { type: String, required: true },
  },
  data() {
    return {
      hovering: false,
    }
  },
  computed: {
    icons() {
      return {
        pose: `mdi-human`,
        'selection set': `mdi-cursor-default`,
        animation: `mdi-play`,
      }
    },
  },
  methods: {
    getRandomHash() {
      // used to force reloading on images (and
      // "disable" caching)
      return shortid.generate();
    },
    poseIsApproved (pose) {
      if (typeof (pose.approved) === 'string')
        return pose.approved === '1';
      return pose.approved;
    },
  },
}
</script>

<template>
  <v-card
    hover
    outlined
    :elevation="4"
    ripple
    class="app-anim-rig__item"
    @mouseenter="() => hovering = true"
    @mouseleave="() => hovering = false"
  >
    <div v-if="poseIsApproved(item)" class="app-anim-rig__poses-grid-item-approved">
      <v-icon>mdi-thumb-up</v-icon>
    </div>
    <div class="app-anim-rig__poses-grid-item-type">
      <v-icon>{{ icons[item.type] }}</v-icon>
    </div>
    <video
      v-if="item.type === 'animation' && hovering && item.thumbnail_movie"
      width="100%"
      height="100%"
      autoplay
      muted
      loop
    >
      <source :src="`/content/uploads/${item.thumbnail_movie}?${getRandomHash()}`" />
    </video>
    <v-img
      v-else
      :src="
        item.thumbnail
          ? `/content/poses/${lib}/${item.thumbnail}?${getRandomHash()}`
          : `/no-pose-image-${$vuetify.theme.dark ? 'dark' : 'light'}.png`
      "
      class="align-end"
    >
      <v-card-text>
        <v-row no-gutters>
          <v-icon v-if="!item.active" class="mr-1">mdi-cancel</v-icon>
          <div>{{ item.name }}</div>
        </v-row>
      </v-card-text>
    </v-img>
  </v-card>
</template>

<style lang="scss" scoped>
.app-anim-rig__poses-grid-item-approved {
  position: absolute;
  top: 4px;
  left: 8px;
  z-index: 1;
}

.app-anim-rig__poses-grid-item-type {
  position: absolute;
  top: 4px;
  right: 4px;
  z-index: 1;
}

.app-anim-rig__item {
  position: relative;
  height: 100%;

  ::v-deep .v-card__text {
    padding: 0px !important;
  }
  ::v-deep .v-responsive__content {
    position: absolute;
    bottom: 2px;
    right: 2px;
    width: auto !important;
    height: auto !important;
  }

  ::v-deep .v-image {
    border-radius: inherit;
  }

  ::v-deep video {
    display: block;
    border-radius: inherit;
  }
}
</style>
